// C Source File
// Created 26/08/01; 16:51:01

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
// short _ti92plus;              // Produce .9XZ File

// Renvoie 1 si un pion est prsent, et 0 dans le cas contraire
int testpres(int x,int ligne)
{
	int i,puissx=1,cell;
	for(i=0;i<x;i++)
	{
		puissx=puissx*2;
	}
  cell=ligne & puissx;
	if (cell>0) { cell=1; }

	return cell; 
}

// Ajoute ou enlve un pion (suivant valeur) aux coordonnes donnes
int modtabl(int x,int ligne,int valeur)
{
	int i,puissx=1;
	for(i=0;i<x;i++)
	{
		puissx=puissx*2;
	}
	
	if (valeur==1) // Mise  1 ex : 1001 OR 0010 => 1011 (9 OR 2 => 11)
	{	
		ligne=ligne|puissx;
	}
	else
	{
		ligne=ligne&(511-puissx);
	}
	return ligne;
}

// Affichage du curseur
void Affcurseur(int x, int y)
{
	int xbase=10, ybase=15;
	DrawPix(xbase+x*10+2,ybase+y*10+2,A_XOR);
	DrawPix(xbase+x*10+8,ybase+y*10+2,A_XOR);
	DrawPix(xbase+x*10+2,ybase+y*10+8,A_XOR);	
	DrawPix(xbase+x*10+8,ybase+y*10+8,A_XOR);	
}

// Inverse les pixels la case slectionne
void LigneSelect(int x, int y)
{
	int xbase=10, ybase=15,i;
	for(i=1;i<10;i++)
	{
		DrawLine(xbase+10*x+1,ybase+10*y+i,xbase+10*x+9,ybase+10*y+i,A_XOR);
	}
}

//  Graphisme du titre
BITMAP Bmp0_C0 = {18,75,{  0x00,0x00,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,
                           0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,
                           0x00,0x00,0x00,0x7F,0x80,0x00,0x01,0xC0,0x00,0x00,
                           0x07,0xE0,0x00,0x63,0x80,0x00,0x01,0xC0,0x00,0x00,
                           0x1F,0xE0,0x00,0xE3,0x80,0x00,0x01,0xC0,0x00,0x00,
                           0x3C,0xE0,0x00,0xE3,0x83,0x00,0x01,0xC0,0x00,0x00,
                           0x38,0xC0,0x00,0xC0,0x07,0x00,0x00,0x00,0x00,0x00,
                           0x3C,0x01,0xE1,0xC7,0x0E,0x03,0xE3,0x87,0x71,0xE0,
                           0x3E,0x07,0xF1,0xCF,0x1F,0xCF,0xE7,0x8F,0xF7,0xE0,
                           0x1F,0x07,0x71,0xDF,0x3F,0xDE,0xEF,0x9F,0xF7,0xE0,
                           0x1F,0x8E,0x71,0xDF,0x3E,0x39,0xEF,0x9F,0xEF,0xE0,
                           0x07,0xDC,0x71,0x87,0x0E,0x39,0xE3,0x87,0x8F,0xC0,
                           0x03,0xDC,0x73,0x86,0x1C,0x73,0xC3,0x07,0x1F,0x00,
                           0x01,0xDC,0x73,0x8E,0x1C,0x77,0xC7,0x0F,0x1C,0x00,
                           0x61,0xDC,0xE3,0xCF,0x9F,0x7F,0xE7,0xCE,0x1C,0xC0,
                           0xF3,0x9D,0xC3,0xEF,0x9F,0x7F,0xE7,0xCE,0x1F,0xC0,
                           0xFF,0x1F,0x83,0xEF,0x1E,0x7D,0xE7,0x8E,0x1F,0x80,
                           0x7E,0x0F,0x03,0x8E,0x1C,0x71,0xC7,0x0C,0x1E,0x00}};

                            
                           
void *Image_C0 = &Bmp0_C0;

unsigned char Pion[] = {0x38,0x7C,0x7C,0x7C,0x38};
 
void _main(void)
{

	char s[2];
	int xbase=10, ybase=15, i, j, codecell, liste, dial, touche, choix, coupsdisp=0;
	int select=0, x, y, xold=0, yold=0, x1=0, y1=0; // Coordonnes des points actuels (x et y), prcdents (xold et yold) et slectionns (x1 et y1)
	
   // Dfinition diffrents tableaux
	int tab[8][8]={{0,0,0,0,0,0,0,0},						 // plateau de jeu
								{0,8,28,8,8,0,0,6},            // croix
								{0,8,8,62,8,8,0,9},            // plus
								{28,28,28,20,0,0,0,11},        // cheminee
								{8,28,62,8,8,28,28,17},        // fleche
								{0,8,28,62,127,0,0,16},        // pyramide
								{8,28,62,119,62,28,8,24},      // carreau
								{28,62,127,119,127,62,28,36}}; // solitaire
								
	// Explication : les 7 premiers nombres correspondent aux lignes de jeu, et le dernier aux nombre de pions au dpart

	/* "Masque"
	Lorsqu'une case est vide, ce tableau permet de savoir dans quel direction 
	"regarder" pour voir si il est possible de jouer un coup vers cette case.
	Ce qui permet de mettre  jour coupsdisp
	Les 7 "chiffres" de droite correspondent chacun  une case, qui est donc
	code sur 4 bits, comme suit :
	
				H B G D
				1 1 1 1  H = on peut accder  cette case par les cases suprieures
	
	Exemple 1 : la case du centre est  la 4me ligne en place 4
	On a F en hexa, soit 1111 en binaire, ce qui signifie que l'on peut accder
   cette case par tous les cts
  
  Exemple 2 : la case en haut  droite est sur la 1re ligne en position 5
  (le plateau est considr comme un carr avec des 0 pour les cases hors-jeu)
  On a un 6 en hexa, soit 0110, ce qui signifie que l'on peut accder  cette
  case par la gauche et le bas
	
	*/
	unsigned long masque[7] = { 0x00064500,0x00667550,0x066FFF55,0x02EFFFD1,0x0AAFFF99,0x00AAB990,0x000A8900};
				
	
	ClrScr();

	// Menu d'accueil
	liste=PopupNew(NULL,70);
	PopupAddText(liste,-1,"Croix",1);
	PopupAddText(liste,-1,"Plus",2);
	PopupAddText(liste,-1,"Chemine",3);
	PopupAddText(liste,-1,"Flche",4);
	PopupAddText(liste,-1,"Pyramide",5);
	PopupAddText(liste,-1,"Carreau",6);
	PopupAddText(liste,-1,"Solitaire",7);
	dial=DialogNewSimple(120,47);
	DialogAddTitle(dial,"Solitaire v1.0 par J. Le Pvdic",BT_OK,BT_CANCEL);
	DialogAddText(dial,20,15,"7 plateaux disponibles");
	DialogAddPulldown(dial,25,24,"Votre choix :",liste,0);
	touche=DialogDo(dial,CENTER,CENTER,NULL,&choix);

	if (touche==KEY_ESC) goto finprog; // ESC : on quitte

	for(i=0;i<8;i++) // TRansfert du plateau choisi vers le plateau de jeu
	{
	tab[0][i]=tab[choix][i];		
	}
	
	// Dessin Titre

	BitmapPut (81, 4, Image_C0, ScrRect, A_NORMAL); 

	DrawClipRect (MakeWinRect (LCD_WIDTH-82, 1, LCD_WIDTH-1, 24), ScrRect, A_NORMAL);
	DrawClipRect (MakeWinRect (LCD_WIDTH-50, 24, LCD_WIDTH-1, 78), ScrRect, A_NORMAL);
	DrawLine(LCD_WIDTH-50,42,LCD_WIDTH-1,42,A_NORMAL);
	DrawLine(LCD_WIDTH-50,60,LCD_WIDTH-1,60,A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(LCD_WIDTH-48,28,"Pions",A_NORMAL);
	DrawStr(LCD_WIDTH-48,34,"Restants",A_NORMAL);
	DrawStr(LCD_WIDTH-48,46,"Coups",A_NORMAL);
	DrawStr(LCD_WIDTH-48,52,"Jous",A_NORMAL);
	DrawStr(LCD_WIDTH-48,64,"Coups",A_NORMAL);
	DrawStr(LCD_WIDTH-48,70,"Possibles :",A_NORMAL);	
	FontSetSys(F_6x8);

	// Dessin de la table
	
	DrawClipRect (MakeWinRect (xbase+10, ybase+10, xbase+60, ybase+60), ScrRect, A_NORMAL);
	
	DrawLine(xbase+20,ybase,xbase+50,ybase,A_NORMAL);
	DrawLine(xbase+20,ybase+70,xbase+50,ybase+70,A_NORMAL);
	DrawLine(xbase,ybase+20,xbase,ybase+50,A_NORMAL);
	DrawLine(xbase+70,ybase+20,xbase+70,ybase+50,A_NORMAL);
	
	for(i=2;i<6;i++)
	{
		DrawLine(xbase+10*i,ybase,xbase+10*i,ybase+70,A_NORMAL);
		DrawLine(xbase,ybase+10*i,xbase+70,ybase+10*i,A_NORMAL);
	}
	
	
	for(y=0;y<7;y++)
	{
		for(x=0;x<7;x++)
		{	
			if (testpres(x,tab[0][y])==1)
			{
				Sprite8(xbase+x*10+2,ybase+y*10+3,5, Pion, LCD_MEM, SPRT_XOR);
			}
		}
	}
	
	x=3;
	y=3;

	do
	{

		// Effacement Barre de statut
	
		ST_showHelp(" ");
		ST_busy(0);

		// Calcul Nombre de coups
		// Ici : i=x et j=y
		coupsdisp=0;
		for(j=0;j<7;j++)
		{
			for(i=0;i<7;i++)
			{
				if (testpres(i,tab[0][j])==0)
				{
					codecell=(masque[j]>>i*4)&0xF;
					if (((codecell&1)==1)&&(testpres(i+1,tab[0][j])==1)&&(testpres(i+2,tab[0][j])==1)) coupsdisp++;
					if (((codecell&2)==2)&&(testpres(i-1,tab[0][j])==1)&&(testpres(i-2,tab[0][j])==1)) coupsdisp++;
					if (((codecell&4)==4)&&(testpres(i,tab[0][j+1])==1)&&(testpres(i,tab[0][j+2])==1)) coupsdisp++;
					if (((codecell&8)==8 )&&(testpres(i,tab[0][j-1])==1)&&(testpres(i,tab[0][j-2])==1)) coupsdisp++;
				}
			}
		}

		// Affichage infos  droite
		DrawStr(LCD_WIDTH-15,30,"  ",A_REPLACE);
		sprintf(s,"%d",tab[0][7]);
		DrawStr(LCD_WIDTH-DrawStrWidth(s,F_6x8)-3,30,s,A_REPLACE); // Pions restants
		sprintf(s,"%d",tab[choix][7]-tab[0][7]);
		DrawStr(LCD_WIDTH-DrawStrWidth(s,F_6x8)-3,48,s,A_REPLACE); // Coups jous
		DrawStr(LCD_WIDTH-15,66,"  ",A_REPLACE);
		sprintf(s,"%d",coupsdisp);
		DrawStr(LCD_WIDTH-DrawStrWidth(s,F_6x8)-3,66,s,A_REPLACE); // Coups possibles
		
		if (coupsdisp==0) // Fin de partie
		{
			for (i=37;i<54;i++)
			{
				DrawLine(12,i,78,i,A_REVERSE);
			}
			DrawClipRect (MakeWinRect (12, 37, 78, 53), ScrRect, A_NORMAL);
			FontSetSys(F_4x6);
			if (tab[0][7]==1) // Gagner
			{	
				DrawStr(14,43,"Vous avez gagn !!",A_NORMAL);
			}
			else // Perdu
			{
				DrawStr(29,39,"Termin !!",A_NORMAL);				
				printf_xy(20,47,"Il reste %d pions",tab[0][7]);				
			}
			ngetchx();
			goto finprog;
		}	

		// Curseur
		Affcurseur(x,y);
		
		// Attente Pression touche	
		touche=ngetchx();
		xold=x;
		yold=y;
	
		// Evite que le curseur sorte du plateau
		// Tout est regroup en 1 ligne par touche pour gagner de la place  la 
		// compilation, mais dcomposer ces lignes pour bien comprendre
		if ((touche==338)&&((((y==0)||(y==6))&&(x>2))||(((y==1)||(y==5))&&(x>1))||(((y>1)&&(y<5))&&(x>0)))) x--; // Gauche
		else if ((touche==344)&&((((y==0)||(y==6))&&(x<4))||(((y==1)||(y==5))&&(x<5))||(((y>1)&&(y<5))&&(x<6)))) x++; // Droite
		else if ((touche==337)&&((((x==0)||(x==6))&&(y>2))||(((x==1)||(x==5))&&(y>1))||(((x>1)&&(x<5))&&(y>0)))) y--; // Haut
		else if ((touche==340)&&((((x==0)||(x==6))&&(y<4))||(((x==1)||(x==5))&&(y<5))||(((x>1)&&(x<5))&&(y<6)))) y++; // Bas
		else if(touche==KEY_ENTER)
		{
			if (select==0)
			{	
				if (testpres(x,tab[0][y])==1)
				{
				// Stockage des coordonnes + Slection du pion (select + lignes noires)
				x1=x;
				y1=y;
				select=1;
				LigneSelect(x1, y1);
				}
			}
			else
			{
			  if (((abs(x-x1)==2)&&(abs(y-y1)==0))||((abs(x-x1)==0)&&(abs(y-y1)==2)))
			  { // Si les positions initiales et finales sont spares de 2 cases en horizontal ou vertical
					if ((testpres(x,tab[0][y])==0)&&(testpres((x+x1)/2,tab[0][(y+y1)/2])==1))
					{
						LigneSelect(x1, y1);
						// Plus de pion slectionn
						select=0;
						// Maj tableau
						tab[0][y]=modtabl(x,tab[0][y],1);
						tab[0][y1]=modtabl(x1,tab[0][y1],0);
						tab[0][(y+y1)/2]=modtabl((x+x1)/2,tab[0][(y+y1)/2],0);

						// Tracs des pions
						Sprite8(xbase+x1*10+2,ybase+y1*10+3,5, Pion, LCD_MEM, SPRT_XOR);
						Sprite8(xbase+(x+x1)*5+2,ybase+(y+y1)*5+3,5, Pion, LCD_MEM, SPRT_XOR); // (x+x1)*5 = (x+x1)/2*10 (/2 : milieu)
						Sprite8(xbase+x*10+2,ybase+y*10+3,5, Pion, LCD_MEM, SPRT_XOR);					

						// MAJ Compteur
						tab[0][7]--;		
					}
			  }
			  if ((abs(x-x1)==0)&&(abs(y-y1)==0))
			  { // Si l'on rappuie au mme endroit
					select=0;
					LigneSelect(x, y);
			  }
			}
		}
		
		// MAJ Curseur
		Affcurseur(xold,yold);
  
  } while (touche!=KEY_ESC);
  
  finprog:

}
